﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Encodings.PermutationEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Problems.BinPacking.Interfaces;

namespace HeuristicLab.Encodings.PackingEncoding.PackingSequence {
  [Item("PackingSequence Inversion Manipulator", "An operator which manipulates a PackingSequence representation.")]
  [StorableClass]
  public class PackingSequenceInversionManipulator : PackingSequenceManipulator, IPackingSequenceOperator {
    [StorableConstructor]
    protected PackingSequenceInversionManipulator(bool deserializing) : base(deserializing) { }
    protected PackingSequenceInversionManipulator(PackingSequenceManipulator original, Cloner cloner) : base(original, cloner) { }
    public PackingSequenceInversionManipulator()
      : base() {
        EncodedSolutionParameter.ActualName = "PackingSequence";
    }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new PackingSequenceInversionManipulator(this, cloner);
    }

    protected override void Manipulate(IRandom random, PackingSequenceEncoding individual) {
      InversionManipulator.Apply(random, individual.PackingSequence);
    }   
  }
}
